// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from wrapyfi_ros2_interfaces:msg/ROS2AudioMessage.idl
// generated code does not contain a copyright notice
#include "wrapyfi_ros2_interfaces/msg/detail/ros2_audio_message__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `encoding`
// Member `coding_format`
#include "rosidl_runtime_c/string_functions.h"
// Member `data`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__init(wrapyfi_ros2_interfaces__msg__ROS2AudioMessage * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__fini(msg);
    return false;
  }
  // chunk_size
  // channels
  // sample_rate
  // encoding
  if (!rosidl_runtime_c__String__init(&msg->encoding)) {
    wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__fini(msg);
    return false;
  }
  // is_bigendian
  // bitrate
  // coding_format
  if (!rosidl_runtime_c__String__init(&msg->coding_format)) {
    wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__fini(msg);
    return false;
  }
  // step
  // data
  if (!rosidl_runtime_c__uint8__Sequence__init(&msg->data, 0)) {
    wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__fini(msg);
    return false;
  }
  return true;
}

void
wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__fini(wrapyfi_ros2_interfaces__msg__ROS2AudioMessage * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // chunk_size
  // channels
  // sample_rate
  // encoding
  rosidl_runtime_c__String__fini(&msg->encoding);
  // is_bigendian
  // bitrate
  // coding_format
  rosidl_runtime_c__String__fini(&msg->coding_format);
  // step
  // data
  rosidl_runtime_c__uint8__Sequence__fini(&msg->data);
}

bool
wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__are_equal(const wrapyfi_ros2_interfaces__msg__ROS2AudioMessage * lhs, const wrapyfi_ros2_interfaces__msg__ROS2AudioMessage * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // chunk_size
  if (lhs->chunk_size != rhs->chunk_size) {
    return false;
  }
  // channels
  if (lhs->channels != rhs->channels) {
    return false;
  }
  // sample_rate
  if (lhs->sample_rate != rhs->sample_rate) {
    return false;
  }
  // encoding
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->encoding), &(rhs->encoding)))
  {
    return false;
  }
  // is_bigendian
  if (lhs->is_bigendian != rhs->is_bigendian) {
    return false;
  }
  // bitrate
  if (lhs->bitrate != rhs->bitrate) {
    return false;
  }
  // coding_format
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->coding_format), &(rhs->coding_format)))
  {
    return false;
  }
  // step
  if (lhs->step != rhs->step) {
    return false;
  }
  // data
  if (!rosidl_runtime_c__uint8__Sequence__are_equal(
      &(lhs->data), &(rhs->data)))
  {
    return false;
  }
  return true;
}

bool
wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__copy(
  const wrapyfi_ros2_interfaces__msg__ROS2AudioMessage * input,
  wrapyfi_ros2_interfaces__msg__ROS2AudioMessage * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // chunk_size
  output->chunk_size = input->chunk_size;
  // channels
  output->channels = input->channels;
  // sample_rate
  output->sample_rate = input->sample_rate;
  // encoding
  if (!rosidl_runtime_c__String__copy(
      &(input->encoding), &(output->encoding)))
  {
    return false;
  }
  // is_bigendian
  output->is_bigendian = input->is_bigendian;
  // bitrate
  output->bitrate = input->bitrate;
  // coding_format
  if (!rosidl_runtime_c__String__copy(
      &(input->coding_format), &(output->coding_format)))
  {
    return false;
  }
  // step
  output->step = input->step;
  // data
  if (!rosidl_runtime_c__uint8__Sequence__copy(
      &(input->data), &(output->data)))
  {
    return false;
  }
  return true;
}

wrapyfi_ros2_interfaces__msg__ROS2AudioMessage *
wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  wrapyfi_ros2_interfaces__msg__ROS2AudioMessage * msg = (wrapyfi_ros2_interfaces__msg__ROS2AudioMessage *)allocator.allocate(sizeof(wrapyfi_ros2_interfaces__msg__ROS2AudioMessage), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(wrapyfi_ros2_interfaces__msg__ROS2AudioMessage));
  bool success = wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__destroy(wrapyfi_ros2_interfaces__msg__ROS2AudioMessage * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence__init(wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  wrapyfi_ros2_interfaces__msg__ROS2AudioMessage * data = NULL;

  if (size) {
    data = (wrapyfi_ros2_interfaces__msg__ROS2AudioMessage *)allocator.zero_allocate(size, sizeof(wrapyfi_ros2_interfaces__msg__ROS2AudioMessage), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence__fini(wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence *
wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence * array = (wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence *)allocator.allocate(sizeof(wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence__destroy(wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence__are_equal(const wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence * lhs, const wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence__copy(
  const wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence * input,
  wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(wrapyfi_ros2_interfaces__msg__ROS2AudioMessage);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    wrapyfi_ros2_interfaces__msg__ROS2AudioMessage * data =
      (wrapyfi_ros2_interfaces__msg__ROS2AudioMessage *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
