// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from wrapyfi_ros2_interfaces:msg/ROS2AudioMessage.idl
// generated code does not contain a copyright notice

#ifndef WRAPYFI_ROS2_INTERFACES__MSG__DETAIL__ROS2_AUDIO_MESSAGE__STRUCT_H_
#define WRAPYFI_ROS2_INTERFACES__MSG__DETAIL__ROS2_AUDIO_MESSAGE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'encoding'
// Member 'coding_format'
#include "rosidl_runtime_c/string.h"
// Member 'data'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in msg/ROS2AudioMessage in the package wrapyfi_ros2_interfaces.
/**
  * Based on https://github.com/ros-drivers/audio_common/blob/main/audio_common_msgs/msg/AudioInfo.msg
 */
typedef struct wrapyfi_ros2_interfaces__msg__ROS2AudioMessage
{
  std_msgs__msg__Header header;
  /// Chunk size
  uint32_t chunk_size;
  /// Number of channels
  uint8_t channels;
  /// Sampling rate
  uint32_t sample_rate;
  /// Audio encoding (e.g. S16LE)
  rosidl_runtime_c__String encoding;
  /// Audio format
  uint8_t is_bigendian;
  /// Amount of audio data per second
  uint32_t bitrate;
  /// Audio coding format (e.g. WAVE, MP3)
  rosidl_runtime_c__String coding_format;
  uint32_t step;
  rosidl_runtime_c__uint8__Sequence data;
} wrapyfi_ros2_interfaces__msg__ROS2AudioMessage;

// Struct for a sequence of wrapyfi_ros2_interfaces__msg__ROS2AudioMessage.
typedef struct wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence
{
  wrapyfi_ros2_interfaces__msg__ROS2AudioMessage * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // WRAPYFI_ROS2_INTERFACES__MSG__DETAIL__ROS2_AUDIO_MESSAGE__STRUCT_H_
