// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from wrapyfi_ros2_interfaces:msg/ROS2AudioMessage.idl
// generated code does not contain a copyright notice

#ifndef WRAPYFI_ROS2_INTERFACES__MSG__DETAIL__ROS2_AUDIO_MESSAGE__FUNCTIONS_H_
#define WRAPYFI_ROS2_INTERFACES__MSG__DETAIL__ROS2_AUDIO_MESSAGE__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "wrapyfi_ros2_interfaces/msg/rosidl_generator_c__visibility_control.h"

#include "wrapyfi_ros2_interfaces/msg/detail/ros2_audio_message__struct.h"

/// Initialize msg/ROS2AudioMessage message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * wrapyfi_ros2_interfaces__msg__ROS2AudioMessage
 * )) before or use
 * wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_wrapyfi_ros2_interfaces
bool
wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__init(wrapyfi_ros2_interfaces__msg__ROS2AudioMessage * msg);

/// Finalize msg/ROS2AudioMessage message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_wrapyfi_ros2_interfaces
void
wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__fini(wrapyfi_ros2_interfaces__msg__ROS2AudioMessage * msg);

/// Create msg/ROS2AudioMessage message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_wrapyfi_ros2_interfaces
wrapyfi_ros2_interfaces__msg__ROS2AudioMessage *
wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__create();

/// Destroy msg/ROS2AudioMessage message.
/**
 * It calls
 * wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_wrapyfi_ros2_interfaces
void
wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__destroy(wrapyfi_ros2_interfaces__msg__ROS2AudioMessage * msg);

/// Check for msg/ROS2AudioMessage message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_wrapyfi_ros2_interfaces
bool
wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__are_equal(const wrapyfi_ros2_interfaces__msg__ROS2AudioMessage * lhs, const wrapyfi_ros2_interfaces__msg__ROS2AudioMessage * rhs);

/// Copy a msg/ROS2AudioMessage message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_wrapyfi_ros2_interfaces
bool
wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__copy(
  const wrapyfi_ros2_interfaces__msg__ROS2AudioMessage * input,
  wrapyfi_ros2_interfaces__msg__ROS2AudioMessage * output);

/// Initialize array of msg/ROS2AudioMessage messages.
/**
 * It allocates the memory for the number of elements and calls
 * wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_wrapyfi_ros2_interfaces
bool
wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence__init(wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence * array, size_t size);

/// Finalize array of msg/ROS2AudioMessage messages.
/**
 * It calls
 * wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_wrapyfi_ros2_interfaces
void
wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence__fini(wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence * array);

/// Create array of msg/ROS2AudioMessage messages.
/**
 * It allocates the memory for the array and calls
 * wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_wrapyfi_ros2_interfaces
wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence *
wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence__create(size_t size);

/// Destroy array of msg/ROS2AudioMessage messages.
/**
 * It calls
 * wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_wrapyfi_ros2_interfaces
void
wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence__destroy(wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence * array);

/// Check for msg/ROS2AudioMessage message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_wrapyfi_ros2_interfaces
bool
wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence__are_equal(const wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence * lhs, const wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence * rhs);

/// Copy an array of msg/ROS2AudioMessage messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_wrapyfi_ros2_interfaces
bool
wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence__copy(
  const wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence * input,
  wrapyfi_ros2_interfaces__msg__ROS2AudioMessage__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // WRAPYFI_ROS2_INTERFACES__MSG__DETAIL__ROS2_AUDIO_MESSAGE__FUNCTIONS_H_
