// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from wrapyfi_ros2_interfaces:msg/ROS2AudioMessage.idl
// generated code does not contain a copyright notice

#ifndef WRAPYFI_ROS2_INTERFACES__MSG__DETAIL__ROS2_AUDIO_MESSAGE__STRUCT_HPP_
#define WRAPYFI_ROS2_INTERFACES__MSG__DETAIL__ROS2_AUDIO_MESSAGE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__wrapyfi_ros2_interfaces__msg__ROS2AudioMessage __attribute__((deprecated))
#else
# define DEPRECATED__wrapyfi_ros2_interfaces__msg__ROS2AudioMessage __declspec(deprecated)
#endif

namespace wrapyfi_ros2_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ROS2AudioMessage_
{
  using Type = ROS2AudioMessage_<ContainerAllocator>;

  explicit ROS2AudioMessage_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->chunk_size = 0ul;
      this->channels = 0;
      this->sample_rate = 0ul;
      this->encoding = "";
      this->is_bigendian = 0;
      this->bitrate = 0ul;
      this->coding_format = "";
      this->step = 0ul;
    }
  }

  explicit ROS2AudioMessage_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    encoding(_alloc),
    coding_format(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->chunk_size = 0ul;
      this->channels = 0;
      this->sample_rate = 0ul;
      this->encoding = "";
      this->is_bigendian = 0;
      this->bitrate = 0ul;
      this->coding_format = "";
      this->step = 0ul;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _chunk_size_type =
    uint32_t;
  _chunk_size_type chunk_size;
  using _channels_type =
    uint8_t;
  _channels_type channels;
  using _sample_rate_type =
    uint32_t;
  _sample_rate_type sample_rate;
  using _encoding_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _encoding_type encoding;
  using _is_bigendian_type =
    uint8_t;
  _is_bigendian_type is_bigendian;
  using _bitrate_type =
    uint32_t;
  _bitrate_type bitrate;
  using _coding_format_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _coding_format_type coding_format;
  using _step_type =
    uint32_t;
  _step_type step;
  using _data_type =
    std::vector<uint8_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint8_t>>;
  _data_type data;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__chunk_size(
    const uint32_t & _arg)
  {
    this->chunk_size = _arg;
    return *this;
  }
  Type & set__channels(
    const uint8_t & _arg)
  {
    this->channels = _arg;
    return *this;
  }
  Type & set__sample_rate(
    const uint32_t & _arg)
  {
    this->sample_rate = _arg;
    return *this;
  }
  Type & set__encoding(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->encoding = _arg;
    return *this;
  }
  Type & set__is_bigendian(
    const uint8_t & _arg)
  {
    this->is_bigendian = _arg;
    return *this;
  }
  Type & set__bitrate(
    const uint32_t & _arg)
  {
    this->bitrate = _arg;
    return *this;
  }
  Type & set__coding_format(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->coding_format = _arg;
    return *this;
  }
  Type & set__step(
    const uint32_t & _arg)
  {
    this->step = _arg;
    return *this;
  }
  Type & set__data(
    const std::vector<uint8_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint8_t>> & _arg)
  {
    this->data = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    wrapyfi_ros2_interfaces::msg::ROS2AudioMessage_<ContainerAllocator> *;
  using ConstRawPtr =
    const wrapyfi_ros2_interfaces::msg::ROS2AudioMessage_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<wrapyfi_ros2_interfaces::msg::ROS2AudioMessage_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<wrapyfi_ros2_interfaces::msg::ROS2AudioMessage_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      wrapyfi_ros2_interfaces::msg::ROS2AudioMessage_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<wrapyfi_ros2_interfaces::msg::ROS2AudioMessage_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      wrapyfi_ros2_interfaces::msg::ROS2AudioMessage_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<wrapyfi_ros2_interfaces::msg::ROS2AudioMessage_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<wrapyfi_ros2_interfaces::msg::ROS2AudioMessage_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<wrapyfi_ros2_interfaces::msg::ROS2AudioMessage_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__wrapyfi_ros2_interfaces__msg__ROS2AudioMessage
    std::shared_ptr<wrapyfi_ros2_interfaces::msg::ROS2AudioMessage_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__wrapyfi_ros2_interfaces__msg__ROS2AudioMessage
    std::shared_ptr<wrapyfi_ros2_interfaces::msg::ROS2AudioMessage_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ROS2AudioMessage_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->chunk_size != other.chunk_size) {
      return false;
    }
    if (this->channels != other.channels) {
      return false;
    }
    if (this->sample_rate != other.sample_rate) {
      return false;
    }
    if (this->encoding != other.encoding) {
      return false;
    }
    if (this->is_bigendian != other.is_bigendian) {
      return false;
    }
    if (this->bitrate != other.bitrate) {
      return false;
    }
    if (this->coding_format != other.coding_format) {
      return false;
    }
    if (this->step != other.step) {
      return false;
    }
    if (this->data != other.data) {
      return false;
    }
    return true;
  }
  bool operator!=(const ROS2AudioMessage_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ROS2AudioMessage_

// alias to use template instance with default allocator
using ROS2AudioMessage =
  wrapyfi_ros2_interfaces::msg::ROS2AudioMessage_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace wrapyfi_ros2_interfaces

#endif  // WRAPYFI_ROS2_INTERFACES__MSG__DETAIL__ROS2_AUDIO_MESSAGE__STRUCT_HPP_
