// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from wrapyfi_ros2_interfaces:msg/ROS2AudioMessage.idl
// generated code does not contain a copyright notice

#ifndef WRAPYFI_ROS2_INTERFACES__MSG__DETAIL__ROS2_AUDIO_MESSAGE__TRAITS_HPP_
#define WRAPYFI_ROS2_INTERFACES__MSG__DETAIL__ROS2_AUDIO_MESSAGE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "wrapyfi_ros2_interfaces/msg/detail/ros2_audio_message__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace wrapyfi_ros2_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const ROS2AudioMessage & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: chunk_size
  {
    out << "chunk_size: ";
    rosidl_generator_traits::value_to_yaml(msg.chunk_size, out);
    out << ", ";
  }

  // member: channels
  {
    out << "channels: ";
    rosidl_generator_traits::value_to_yaml(msg.channels, out);
    out << ", ";
  }

  // member: sample_rate
  {
    out << "sample_rate: ";
    rosidl_generator_traits::value_to_yaml(msg.sample_rate, out);
    out << ", ";
  }

  // member: encoding
  {
    out << "encoding: ";
    rosidl_generator_traits::value_to_yaml(msg.encoding, out);
    out << ", ";
  }

  // member: is_bigendian
  {
    out << "is_bigendian: ";
    rosidl_generator_traits::value_to_yaml(msg.is_bigendian, out);
    out << ", ";
  }

  // member: bitrate
  {
    out << "bitrate: ";
    rosidl_generator_traits::value_to_yaml(msg.bitrate, out);
    out << ", ";
  }

  // member: coding_format
  {
    out << "coding_format: ";
    rosidl_generator_traits::value_to_yaml(msg.coding_format, out);
    out << ", ";
  }

  // member: step
  {
    out << "step: ";
    rosidl_generator_traits::value_to_yaml(msg.step, out);
    out << ", ";
  }

  // member: data
  {
    if (msg.data.size() == 0) {
      out << "data: []";
    } else {
      out << "data: [";
      size_t pending_items = msg.data.size();
      for (auto item : msg.data) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ROS2AudioMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: chunk_size
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "chunk_size: ";
    rosidl_generator_traits::value_to_yaml(msg.chunk_size, out);
    out << "\n";
  }

  // member: channels
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "channels: ";
    rosidl_generator_traits::value_to_yaml(msg.channels, out);
    out << "\n";
  }

  // member: sample_rate
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sample_rate: ";
    rosidl_generator_traits::value_to_yaml(msg.sample_rate, out);
    out << "\n";
  }

  // member: encoding
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "encoding: ";
    rosidl_generator_traits::value_to_yaml(msg.encoding, out);
    out << "\n";
  }

  // member: is_bigendian
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "is_bigendian: ";
    rosidl_generator_traits::value_to_yaml(msg.is_bigendian, out);
    out << "\n";
  }

  // member: bitrate
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "bitrate: ";
    rosidl_generator_traits::value_to_yaml(msg.bitrate, out);
    out << "\n";
  }

  // member: coding_format
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "coding_format: ";
    rosidl_generator_traits::value_to_yaml(msg.coding_format, out);
    out << "\n";
  }

  // member: step
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "step: ";
    rosidl_generator_traits::value_to_yaml(msg.step, out);
    out << "\n";
  }

  // member: data
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.data.size() == 0) {
      out << "data: []\n";
    } else {
      out << "data:\n";
      for (auto item : msg.data) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ROS2AudioMessage & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace wrapyfi_ros2_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use wrapyfi_ros2_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const wrapyfi_ros2_interfaces::msg::ROS2AudioMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  wrapyfi_ros2_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use wrapyfi_ros2_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const wrapyfi_ros2_interfaces::msg::ROS2AudioMessage & msg)
{
  return wrapyfi_ros2_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<wrapyfi_ros2_interfaces::msg::ROS2AudioMessage>()
{
  return "wrapyfi_ros2_interfaces::msg::ROS2AudioMessage";
}

template<>
inline const char * name<wrapyfi_ros2_interfaces::msg::ROS2AudioMessage>()
{
  return "wrapyfi_ros2_interfaces/msg/ROS2AudioMessage";
}

template<>
struct has_fixed_size<wrapyfi_ros2_interfaces::msg::ROS2AudioMessage>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<wrapyfi_ros2_interfaces::msg::ROS2AudioMessage>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<wrapyfi_ros2_interfaces::msg::ROS2AudioMessage>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // WRAPYFI_ROS2_INTERFACES__MSG__DETAIL__ROS2_AUDIO_MESSAGE__TRAITS_HPP_
