// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from wrapyfi_ros2_interfaces:srv/ROS2AudioService.idl
// generated code does not contain a copyright notice

#ifndef WRAPYFI_ROS2_INTERFACES__SRV__DETAIL__ROS2_AUDIO_SERVICE__TRAITS_HPP_
#define WRAPYFI_ROS2_INTERFACES__SRV__DETAIL__ROS2_AUDIO_SERVICE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "wrapyfi_ros2_interfaces/srv/detail/ros2_audio_service__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace wrapyfi_ros2_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const ROS2AudioService_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: request
  {
    out << "request: ";
    rosidl_generator_traits::value_to_yaml(msg.request, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ROS2AudioService_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "request: ";
    rosidl_generator_traits::value_to_yaml(msg.request, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ROS2AudioService_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace wrapyfi_ros2_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use wrapyfi_ros2_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const wrapyfi_ros2_interfaces::srv::ROS2AudioService_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  wrapyfi_ros2_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use wrapyfi_ros2_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const wrapyfi_ros2_interfaces::srv::ROS2AudioService_Request & msg)
{
  return wrapyfi_ros2_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<wrapyfi_ros2_interfaces::srv::ROS2AudioService_Request>()
{
  return "wrapyfi_ros2_interfaces::srv::ROS2AudioService_Request";
}

template<>
inline const char * name<wrapyfi_ros2_interfaces::srv::ROS2AudioService_Request>()
{
  return "wrapyfi_ros2_interfaces/srv/ROS2AudioService_Request";
}

template<>
struct has_fixed_size<wrapyfi_ros2_interfaces::srv::ROS2AudioService_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<wrapyfi_ros2_interfaces::srv::ROS2AudioService_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<wrapyfi_ros2_interfaces::srv::ROS2AudioService_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'response'
#include "wrapyfi_ros2_interfaces/msg/detail/ros2_audio_message__traits.hpp"

namespace wrapyfi_ros2_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const ROS2AudioService_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: response
  {
    out << "response: ";
    to_flow_style_yaml(msg.response, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ROS2AudioService_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "response:\n";
    to_block_style_yaml(msg.response, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ROS2AudioService_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace wrapyfi_ros2_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use wrapyfi_ros2_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const wrapyfi_ros2_interfaces::srv::ROS2AudioService_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  wrapyfi_ros2_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use wrapyfi_ros2_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const wrapyfi_ros2_interfaces::srv::ROS2AudioService_Response & msg)
{
  return wrapyfi_ros2_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<wrapyfi_ros2_interfaces::srv::ROS2AudioService_Response>()
{
  return "wrapyfi_ros2_interfaces::srv::ROS2AudioService_Response";
}

template<>
inline const char * name<wrapyfi_ros2_interfaces::srv::ROS2AudioService_Response>()
{
  return "wrapyfi_ros2_interfaces/srv/ROS2AudioService_Response";
}

template<>
struct has_fixed_size<wrapyfi_ros2_interfaces::srv::ROS2AudioService_Response>
  : std::integral_constant<bool, has_fixed_size<wrapyfi_ros2_interfaces::msg::ROS2AudioMessage>::value> {};

template<>
struct has_bounded_size<wrapyfi_ros2_interfaces::srv::ROS2AudioService_Response>
  : std::integral_constant<bool, has_bounded_size<wrapyfi_ros2_interfaces::msg::ROS2AudioMessage>::value> {};

template<>
struct is_message<wrapyfi_ros2_interfaces::srv::ROS2AudioService_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<wrapyfi_ros2_interfaces::srv::ROS2AudioService>()
{
  return "wrapyfi_ros2_interfaces::srv::ROS2AudioService";
}

template<>
inline const char * name<wrapyfi_ros2_interfaces::srv::ROS2AudioService>()
{
  return "wrapyfi_ros2_interfaces/srv/ROS2AudioService";
}

template<>
struct has_fixed_size<wrapyfi_ros2_interfaces::srv::ROS2AudioService>
  : std::integral_constant<
    bool,
    has_fixed_size<wrapyfi_ros2_interfaces::srv::ROS2AudioService_Request>::value &&
    has_fixed_size<wrapyfi_ros2_interfaces::srv::ROS2AudioService_Response>::value
  >
{
};

template<>
struct has_bounded_size<wrapyfi_ros2_interfaces::srv::ROS2AudioService>
  : std::integral_constant<
    bool,
    has_bounded_size<wrapyfi_ros2_interfaces::srv::ROS2AudioService_Request>::value &&
    has_bounded_size<wrapyfi_ros2_interfaces::srv::ROS2AudioService_Response>::value
  >
{
};

template<>
struct is_service<wrapyfi_ros2_interfaces::srv::ROS2AudioService>
  : std::true_type
{
};

template<>
struct is_service_request<wrapyfi_ros2_interfaces::srv::ROS2AudioService_Request>
  : std::true_type
{
};

template<>
struct is_service_response<wrapyfi_ros2_interfaces::srv::ROS2AudioService_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // WRAPYFI_ROS2_INTERFACES__SRV__DETAIL__ROS2_AUDIO_SERVICE__TRAITS_HPP_
