// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from wrapyfi_ros2_interfaces:srv/ROS2ImageService.idl
// generated code does not contain a copyright notice

#ifndef WRAPYFI_ROS2_INTERFACES__SRV__DETAIL__ROS2_IMAGE_SERVICE__STRUCT_HPP_
#define WRAPYFI_ROS2_INTERFACES__SRV__DETAIL__ROS2_IMAGE_SERVICE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__wrapyfi_ros2_interfaces__srv__ROS2ImageService_Request __attribute__((deprecated))
#else
# define DEPRECATED__wrapyfi_ros2_interfaces__srv__ROS2ImageService_Request __declspec(deprecated)
#endif

namespace wrapyfi_ros2_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct ROS2ImageService_Request_
{
  using Type = ROS2ImageService_Request_<ContainerAllocator>;

  explicit ROS2ImageService_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->request = "";
    }
  }

  explicit ROS2ImageService_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : request(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->request = "";
    }
  }

  // field types and members
  using _request_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _request_type request;

  // setters for named parameter idiom
  Type & set__request(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->request = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    wrapyfi_ros2_interfaces::srv::ROS2ImageService_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const wrapyfi_ros2_interfaces::srv::ROS2ImageService_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<wrapyfi_ros2_interfaces::srv::ROS2ImageService_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<wrapyfi_ros2_interfaces::srv::ROS2ImageService_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      wrapyfi_ros2_interfaces::srv::ROS2ImageService_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<wrapyfi_ros2_interfaces::srv::ROS2ImageService_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      wrapyfi_ros2_interfaces::srv::ROS2ImageService_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<wrapyfi_ros2_interfaces::srv::ROS2ImageService_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<wrapyfi_ros2_interfaces::srv::ROS2ImageService_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<wrapyfi_ros2_interfaces::srv::ROS2ImageService_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__wrapyfi_ros2_interfaces__srv__ROS2ImageService_Request
    std::shared_ptr<wrapyfi_ros2_interfaces::srv::ROS2ImageService_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__wrapyfi_ros2_interfaces__srv__ROS2ImageService_Request
    std::shared_ptr<wrapyfi_ros2_interfaces::srv::ROS2ImageService_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ROS2ImageService_Request_ & other) const
  {
    if (this->request != other.request) {
      return false;
    }
    return true;
  }
  bool operator!=(const ROS2ImageService_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ROS2ImageService_Request_

// alias to use template instance with default allocator
using ROS2ImageService_Request =
  wrapyfi_ros2_interfaces::srv::ROS2ImageService_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace wrapyfi_ros2_interfaces


// Include directives for member types
// Member 'response'
#include "sensor_msgs/msg/detail/image__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__wrapyfi_ros2_interfaces__srv__ROS2ImageService_Response __attribute__((deprecated))
#else
# define DEPRECATED__wrapyfi_ros2_interfaces__srv__ROS2ImageService_Response __declspec(deprecated)
#endif

namespace wrapyfi_ros2_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct ROS2ImageService_Response_
{
  using Type = ROS2ImageService_Response_<ContainerAllocator>;

  explicit ROS2ImageService_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : response(_init)
  {
    (void)_init;
  }

  explicit ROS2ImageService_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : response(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _response_type =
    sensor_msgs::msg::Image_<ContainerAllocator>;
  _response_type response;

  // setters for named parameter idiom
  Type & set__response(
    const sensor_msgs::msg::Image_<ContainerAllocator> & _arg)
  {
    this->response = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    wrapyfi_ros2_interfaces::srv::ROS2ImageService_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const wrapyfi_ros2_interfaces::srv::ROS2ImageService_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<wrapyfi_ros2_interfaces::srv::ROS2ImageService_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<wrapyfi_ros2_interfaces::srv::ROS2ImageService_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      wrapyfi_ros2_interfaces::srv::ROS2ImageService_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<wrapyfi_ros2_interfaces::srv::ROS2ImageService_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      wrapyfi_ros2_interfaces::srv::ROS2ImageService_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<wrapyfi_ros2_interfaces::srv::ROS2ImageService_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<wrapyfi_ros2_interfaces::srv::ROS2ImageService_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<wrapyfi_ros2_interfaces::srv::ROS2ImageService_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__wrapyfi_ros2_interfaces__srv__ROS2ImageService_Response
    std::shared_ptr<wrapyfi_ros2_interfaces::srv::ROS2ImageService_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__wrapyfi_ros2_interfaces__srv__ROS2ImageService_Response
    std::shared_ptr<wrapyfi_ros2_interfaces::srv::ROS2ImageService_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ROS2ImageService_Response_ & other) const
  {
    if (this->response != other.response) {
      return false;
    }
    return true;
  }
  bool operator!=(const ROS2ImageService_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ROS2ImageService_Response_

// alias to use template instance with default allocator
using ROS2ImageService_Response =
  wrapyfi_ros2_interfaces::srv::ROS2ImageService_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace wrapyfi_ros2_interfaces

namespace wrapyfi_ros2_interfaces
{

namespace srv
{

struct ROS2ImageService
{
  using Request = wrapyfi_ros2_interfaces::srv::ROS2ImageService_Request;
  using Response = wrapyfi_ros2_interfaces::srv::ROS2ImageService_Response;
};

}  // namespace srv

}  // namespace wrapyfi_ros2_interfaces

#endif  // WRAPYFI_ROS2_INTERFACES__SRV__DETAIL__ROS2_IMAGE_SERVICE__STRUCT_HPP_
